VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsAeDAL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Not The most advanced Data Access Layer in the world!
'
'The clsAeDAL class is used to represent a typical data access
'layer, found in client/server front ends. The functionality is
'minimal, and saves data to a text file.
'
'by David Bayley, 15-Nov-1998

Option Explicit

Private Const M_MaxNoRecords = 100
Private Const M_FieldCount = 8

'Private variables
Private m_Data(M_MaxNoRecords, 1 To M_FieldCount) As Variant
Private m_Modified As Boolean
Private m_Current As Integer
Private m_Count As Integer
Private M_TextFile As String

'Public Methods
'=============
Public Function OpenData(ByVal TextFile As String) As Boolean

    On Error GoTo ErrorHandler
    
    Dim hFile As Integer
    hFile = FreeFile
    M_TextFile = TextFile
    Open M_TextFile For Input As #hFile
    
    Input #hFile, m_Count
    
    Dim iRec As Integer
    Dim iField As Integer
    For iRec = 1 To m_Count
        For iField = 1 To M_FieldCount
            Input #hFile, m_Data(iRec, iField)
        Next iField
    Next iRec
    
    If m_Count <> 0 Then m_Current = 1
    
    OpenData = True
ErrorExit:
    Close #hFile
    Exit Function
ErrorHandler:
    If Err.Number <> 62 Then 'input past end of file then
        MsgBox Err.Description & vbCrLf & CStr(Err.Number), vbOKOnly, "clsAeDAL.OpenData Error"
        OpenData = False
    End If
    Resume ErrorExit
End Function

Public Function Update() As Boolean

    If m_Modified Then
    
        On Error GoTo ErrorHandler
        Dim hFile As Integer
        hFile = FreeFile
        Open M_TextFile For Output As #hFile
    
        Print #hFile, m_Count
        Dim iRec As Integer
        Dim iField As Integer
        For iRec = 1 To m_Count
            For iField = 1 To M_FieldCount
                Write #hFile, m_Data(iRec, iField)
            Next iField
        Next iRec
        Print #hFile, "End of File"
        
    End If

    m_Modified = False
    
    Update = True
ErrorExit:
    If hFile Then Close #hFile
    Exit Function
ErrorHandler:
    MsgBox Err.Description & vbCrLf & CStr(Err.Number), vbOKOnly, "clsAeDAL.Update Error"
    Update = False
    Resume ErrorExit:
End Function

Public Sub MoveNext()
    m_Current = m_Current + 1
    If m_Current > m_Count Then m_Current = 0
End Sub

Public Sub MovePrevious()
    m_Current = m_Current - 1
    If m_Current < 0 Then m_Current = m_Count
End Sub

Public Sub MoveFirst()
    m_Current = 1
End Sub

Public Sub MoveLast()
    m_Current = m_Count
End Sub

Public Function Add() As Long
    'just add on the end
    If m_Count = M_MaxNoRecords Then
        MsgBox "The database is full up", vbOKOnly, "clsAeDAL.Add"
        Add = 0
    Else
        m_Count = m_Count + 1
        m_Current = m_Count
        m_Modified = True
        Add = m_Count
    End If
End Function

Public Sub Delete()
    If m_Current <> 0 Then
    
        m_Count = m_Count - 1
        
        'just remove from array, crude but effective
        Dim iRec As Integer
        Dim iField As Integer
        For iRec = m_Current To m_Count
            For iField = 1 To M_FieldCount
                m_Data(iRec, iField) = m_Data(iRec + 1, iField)
            Next iField
        Next iRec
        For iField = 1 To M_FieldCount
            m_Data(m_Count + 1, iField) = Empty
        Next iField
        
        If m_Current > m_Count Then m_Current = m_Count
        m_Modified = True
        
    End If
    
End Sub

'Public Properties
'===============
Public Property Get Fields(ByVal Index As Variant) As Variant
Attribute Fields.VB_UserMemId = 0
    Fields = m_Data(m_Current, Index)
End Property
Public Property Let Fields(ByVal Index As Variant, ByVal NewValue As Variant)
    If m_Data(m_Current, Index) <> NewValue Then
        m_Data(m_Current, Index) = NewValue
        m_Modified = True
    End If
End Property

Public Property Get RecordCount() As Long
    RecordCount = m_Count
End Property

Public Property Get CurrentRecord() As Long
    CurrentRecord = m_Current
End Property

Public Property Get Modified() As Boolean
    Modified = m_Modified
End Property
