VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsAeFileCommDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Windows API
Private Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Declare Function GetOpenFileName Lib "ComDlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_ENABLEHOOK = &H20
Private Const OFN_ENABLETEMPLATE = &H40
Private Const OFN_ENABLETEMPLATEHANDLE = &H80
Private Const OFN_EXPLORER = &H80000
Private Const OFN_EXTENSIONDIFFERENT = &H400
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_LONGNAMES = &H200000
Private Const OFN_NOCHANGEDIR = &H8
Private Const OFN_NODEREFERENCELINKS = &H100000
Private Const OFN_NOLONGNAMES = &H40000
Private Const OFN_NONETWORKBUTTON = &H20000
Private Const OFN_NOREADONLYRETURN = &H8000
Private Const OFN_NOTESTFILECREATE = &H10000
Private Const OFN_NOVALIDATE = &H100
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_READONLY = &H1
Private Const OFN_SHAREAWARE = &H4000
Private Const OFN_SHAREFALLTHROUGH = 2
Private Const OFN_SHARENOWARN = 1
Private Const OFN_SHAREWARN = 0
Private Const OFN_SHOWHELP = &H10
Private Const OFS_MAXPATHNAME = 128

Private Declare Function CommDlgExtendedError Lib "ComDlg32.dll" () As Long

Private Const CDERR_DIALOGFAILURE = &HFFFF
Private Const CDERR_FINDRESFAILURE = &H6
Private Const CDERR_GENERALCODES = &H0
Private Const CDERR_INITIALIZATION = &H2
Private Const CDERR_LOADRESFAILURE = &H7
Private Const CDERR_LOADSTRFAILURE = &H5
Private Const CDERR_LOCKRESFAILURE = &H8
Private Const CDERR_MEMALLOCFAILURE = &H9
Private Const CDERR_MEMLOCKFAILURE = &HA
Private Const CDERR_NOHINSTANCE = &H4
Private Const CDERR_NOHOOK = &HB
Private Const CDERR_NOTEMPLATE = &H3
Private Const CDERR_REGISTERMSGFAIL = &HC
Private Const CDERR_STRUCTSIZE = &H1 '1
Private Const FNERR_BUFFERTOOSMALL = &H3003 '12291
Private Const FNERR_FILENAMECODES = &H3000
Private Const FNERR_INVALIDFILENAME = &H3002 '12290
Private Const FNERR_SUBCLASSFAILURE = &H3001

Private Declare Function GetFileTitle Lib "ComDlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer

Private m_OFN As OPENFILENAME

'Public Enumerations
Public Enum AeCommDlgStyles
    aeAllFiles
    aePictures
End Enum

'Public Properties
'===============
Public Property Get FileName() As String
    FileName = m_OFN.lpstrFile
End Property

Public Property Get FileTitle() As String
    FileTitle = m_OFN.lpstrFileTitle
End Property

Public Property Let Style(ByVal New_Style As AeCommDlgStyles)

    Dim sFileTitle As String
    Dim sFile As String
    Dim s As String
    m_OFN.lStructSize = Len(m_OFN)
    
    Select Case New_Style
    
        Case aeAllFiles
        
            s = "All Files (*.*)" & Chr$(0) & "*.*" & Chr$(0)
            s = s & Chr$(0)
            m_OFN.lpstrFilter = s
            m_OFN.nFilterIndex = 1
            
            m_OFN.lpstrTitle = "Load File" & Chr$(0)
        
        Case aePictures
            
            s = "All Picture Files" & Chr$(0) & "*.bmp;*.ico;*.rle;*.wmf;*.gif;*.jpg" & Chr$(0)
            s = s & "Bitmaps (*.bmp;*.dib)" & Chr$(0) & "*.bmp;*.dib" & Chr$(0)
            s = s & "Icons (*.ico;*.cur))" & Chr$(0) & "*.ico" & Chr$(0)
            s = s & "Metafiles (*.wmf;*.emf)" & Chr$(0) & "*.wmf;*.emf" & Chr$(0)
            s = s & "GIF Images (*.gif)" & Chr$(0) & "*.gif" & Chr$(0)
            s = s & "JPEG Images (*.jpg)" & Chr$(0) & "*.jpg" & Chr$(0)
            s = s & "All Files (*.*)" & Chr$(0) & "*.*" & Chr$(0)
            s = s & Chr$(0)
            m_OFN.lpstrFilter = s
            m_OFN.nFilterIndex = 1
            
            m_OFN.lpstrTitle = "Load Picture" & Chr$(0)
            
        'Case aeDifferent
            'add your other styles here
            
    End Select
    
    sFile = String(2000, 0)
    m_OFN.lpstrFile = sFile
    m_OFN.nMaxFile = 2000
    
    sFileTitle = String(256, 0)
    m_OFN.lpstrFileTitle = sFileTitle
    m_OFN.nMaxFileTitle = 256
    
    'these flags could be migrated into additional properties and/or styles
    m_OFN.flags = OFN_HIDEREADONLY Or OFN_NONETWORKBUTTON Or OFN_FILEMUSTEXIST
    
End Property

'Public Methods
'=============
Public Function ShowOpen(ByVal hWnd As Long) As Boolean

    Dim lRet As Long

    m_OFN.hwndOwner = hWnd
    
    lRet = GetOpenFileName(m_OFN)
    
    ShowOpen = (lRet <> 0)
    'lRet = CommDlgExtendedError()

End Function

'Private Events
'============
Private Sub Class_Initialize()
    Style = aeAllFiles
End Sub
