VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsTimeZones"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const M_MaxCountries = 400
Private Const M_DataFileName = "TimeZones.txt"

Private Type tagCountry
    Name As String
    Cities() As clsTimeZone
    Count As Integer
End Type
    
'Private Variables
Private m_Countries(M_MaxCountries) As tagCountry
Private m_Count As Integer

'Public Methods
'==============
Public Sub InitialiseData()

    Dim iFile As Integer
    Dim oNewZone As clsTimeZone
    Dim sLine As String
    Dim s As String
    Dim iCountry As Integer
    
    On Error GoTo ErrorHandler
    
    'open up the text file containing the Time Zone information
    iFile = FreeFile
    Dim sPath As String
    sPath = App.Path
    If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"
    If InStr(sPath, "\Global Clock") Then sPath = sPath & "..\"
    Open sPath & M_DataFileName For Input As iFile
    
    'skip first 4 lines...
    Line Input #iFile, sLine
    Line Input #iFile, sLine
    Line Input #iFile, sLine
    Line Input #iFile, sLine
    '...and prime
    Line Input #iFile, sLine
    
    'loop through each line
    While Not EOF(iFile)
    
        'parse country, and add if new
        s = Trim$(Left$(sLine, 23))
        If s <> m_Countries(iCountry).Name Then
            iCountry = iCountry + 1
            m_Countries(iCountry).Name = s
        End If
        
        'parse the city info, and add new TimeZone
        s = Mid$(sLine, 24)
        Set oNewZone = New clsTimeZone
        With m_Countries(iCountry)
            .Count = .Count + 1
            ReDim Preserve .Cities(1 To .Count)
            Set .Cities(.Count) = oNewZone
        End With
        oNewZone.ParseData s
    
        'read the next line
        Line Input #iFile, sLine
    Wend
    
    m_Count = iCountry
    
ErrorExit:
    Close iFile
    Exit Sub
ErrorHandler:
    MsgBox Err.Description & vbCrLf & "#" & CStr(Err.Number), vbOKOnly + vbInformation, "clsTimeZone.InitialiseData"
    m_Count = 0
    Resume ErrorExit
End Sub

Public Function FindCountry(ByVal SearchText As String) As Integer
    Dim n As Integer
    For n = 1 To m_Count
        If StrComp(m_Countries(n).Name, SearchText, vbTextCompare) = 0 Then Exit For
    Next n
    If n > m_Count Then n = 0
    FindCountry = n
End Function

'Public Properties
'===============
Public Property Get Item(ByVal CountryIndex As Integer, ByVal CityIndex As Integer) As clsTimeZone
    Set Item = m_Countries(CountryIndex).Cities(CityIndex)
End Property

Public Property Get ItemCount(ByVal CountryIndex As Integer) As Integer
    ItemCount = m_Countries(CountryIndex).Count
End Property

Public Property Get CountryCount() As Integer
    CountryCount = m_Count
End Property

Public Property Get CountryNames(ByVal Index As Integer) As String
    CountryNames = m_Countries(Index).Name
End Property

